﻿using UnityEngine;
using System.Collections.Generic;

public class EnemyMovementArray : MonoBehaviour {

	public List<Transform> patrolPoints = new List<Transform>();
	public Transform currentPatrolPoint;
	public int currentPatrolNumber = 0;
	public float speed = 2f;
	//add timer
	public float timeToWait = 3f;
	public float timeSpentWaiting = 0f;

	//Attack
	public bool isAttacking = false;







	// Use this for initialization
	void Start () {
		speed = Random.Range (1.75f, 3f);
		timeToWait = Random.Range (1f, 4f);
		currentPatrolPoint = patrolPoints [0];
	
	}
	
	// Update is called once per frame
	void Update () {
		MoveEnemy();
	}
	public void MoveEnemy(){
			//move towards current patrol point 
			transform.position = Vector2.MoveTowards
				(transform.position, currentPatrolPoint.position, speed * Time.deltaTime);
		//check distance between this game object and the patrol point
		float distanceToCurrent = Vector2.Distance
			(transform.position, currentPatrolPoint.position);

			if (distanceToCurrent == 0f){
				if (currentPatrolNumber != patrolPoints.Count-1){
					timeSpentWaiting += Time.deltaTime;

					if (timeSpentWaiting >= timeToWait){
						currentPatrolNumber ++;
						currentPatrolPoint = patrolPoints[currentPatrolNumber];
					timeSpentWaiting = 0;

					}else{
						timeSpentWaiting += Time.deltaTime;
					if(timeSpentWaiting >= timeToWait){
							currentPatrolNumber = 0;
							currentPatrolPoint = patrolPoints[currentPatrolNumber];

							timeSpentWaiting =0;
						}

					}
				}
	 		}
	}


		//public void chasePlayer(Transform playerToChase){
		//	}

public void LeapAtEnemy(Transform positionToLeapTo){
	if (!isAttacking) {
		isAttacking = true;
		Vector3 midpoint = new Vector3(transform.position.x + positionToLeapTo.position.x / 2,
		                              transform.position.y + positionToLeapTo.position.y / 10,
		                             transform.position.z + positionToLeapTo.position.z / 2);

	  Vector3[] newPath;
		newPath = new Vector3[3];
		newPath [0] = transform.position;
		newPath [1] = midpoint;
		newPath [2] = positionToLeapTo.position;

		iTween.MoveTo(gameObject, iTween.Hash("path", newPath,
		           "easyType", "easeInOutExpo", "loopType" , "none",
			                                      "time", 1f, "onComplete", "FinishLeapAttack"));
		}
		}		


public void FinishLeapAttack(){
	isAttacking = false;
}
}




